function [ER,ERknn,Precision,Recall,F1,FalsePR,Confusion,E,Eknn,OutPut]=Train_lndspanno_cv(name,EN,KernelType_p,KernelType,ErrType,Csvm,Csvm2,Ksvm,PList,kappa,s_count,nd)


% parameter
close all;
Data=['../Data/',name,'/',name];
disp(s_count);
InputData=[Data,'_K_Ynoise',num2str(EN),'.mat'];
load(InputData);
if strcmp(KernelType,'Gauss')
Ks=Kg;
else
Ks=K;
end
if strcmp(KernelType_p,'Gauss');
Kk=Kg.^kappa;
else
Kk=K;
end


clear K Kg;
%learn cv
for r_count=1:1:10
Y=Yt;
if strcmp(ErrType,'R1')
Y(idTrain(find(InRNoise(r_count,1,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InRNoise(r_count,1,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'R2')
Y(idTrain(find(InRNoise(r_count,2,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InRNoise(r_count,2,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'M1')
Y(idTrain(find(InMNoise(r_count,1,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InMNoise(r_count,1,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'M2')
Y(idTrain(find(InMNoise(r_count,2,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InMNoise(r_count,2,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'ML1')
Y(idTrain(find(InMLNoise(r_count,1,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InMLNoise(r_count,1,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'ML2')
Y(idTrain(find(InMLNoise(r_count,2,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InMLNoise(r_count,2,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'WC1')
Y(idTrain(find(InWCNoise(r_count,1,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InWCNoise(r_count,1,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'WC2')
Y(idTrain(find(InWCNoise(r_count,2,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InWCNoise(r_count,2,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'H1')
Y(idTrain(find(InHNoise(r_count,1,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InHNoise(r_count,1,s_count,:)==-1),r_count));
end
if strcmp(ErrType,'H2')
Y(idTrain(find(InHNoise(r_count,2,s_count,:)==-1),r_count))=-1*Yt(idTrain(find(InHNoise(r_count,2,s_count,:)==-1),r_count));
end





for cv=1:1:6
%train
TR=[];
TS=[];
Ytr=[];
Yts=[];
Ktr=[];
Kts=[];
sKtr=[];
sKts=[];
if cv==6
TR=[idTrain(:,r_count);idVal(:,r_count)];
TS=idTest(:,r_count);
[~,id_expert,~]=intersect(TR,idVal(:,r_count));
else
TR=find(CVI(r_count,cv,:)==1);
TS=find(CVI(r_count,cv,:)==-1);
[~,id_expert,~]=intersect(TR,idVal(:,r_count));
end

Ktr=Kk(TR,TR);
Kts=Kk(TR,TS);
sKtr=Ks(TR,TR);
sKts=Ks(TR,TS);

Ytr=Y(TR);
Yts=Y(TS);

nn=length(find(Ytr==-1));
np=length(find(Ytr==1));
Ner=min(nn,np);
kList=floor(Ner*PList);

[AllYp,spT]=LND_spanno(Ktr,kList,id_expert,Ytr,nd);
OutPut(r_count,cv).Yp=AllYp;
OutPut(r_count,cv).St=spT;


for k =1:1:length(kList)
Yp=AllYp(:,k);
out=find(Yp~=Ytr);
in=find(Yp==Ytr);
outT=find(Yt(TR)~=Ytr);
inT=find(Yt(TR)==Ytr);
Pre(k,r_count,cv)=length(intersect(out,outT))/length(out);
if(length(out)==0)
Pre(k,r_count,cv)=0;
end
Rec(k,r_count,cv)=length(intersect(out,outT))/length(outT);
Fone(k,r_count,cv)=(2*Pre(k,r_count,cv)*Rec(k,r_count,cv))/(Pre(k,r_count,cv)+Rec(k,r_count,cv));
if(Pre(k,r_count,cv)==0 & Rec(k,r_count,cv)==0)
Fone(k,r_count,cv)=0;
end
Fpr(k,r_count,cv)=length(setdiff(out,outT))/length(inT);

% ConfusionMAtrix = tp(true correct label) tn(true outlier) fp fn 
Confusion(k,r_count,cv,1)=length(intersect(in,inT));
Confusion(k,r_count,cv,2)=length(intersect(out,outT));
Confusion(k,r_count,cv,3)=length(intersect(in,outT));
Confusion(k,r_count,cv,4)=length(intersect(out,inT));
Confusion(k,r_count,cv,7)=Fone(k,r_count,cv); % with respect to outlier
Confusion(k,r_count,cv,6)=Rec(k,r_count,cv);
Confusion(k,r_count,cv,5)=Pre(k,r_count,cv);
Confusion(k,r_count,cv,8)=length(intersect(in,inT))/length(in); % with respect to correct label
Confusion(k,r_count,cv,9)=length(intersect(in,inT))/length(inT);
Confusion(k,r_count,cv,10)=(2*Confusion(k,r_count,cv,8)*Confusion(k,r_count,cv,9))/(Confusion(k,r_count,cv,8)+Confusion(k,r_count,cv,9));;

[~,Eknn(k,r_count,cv)]=TestKnn(Kts,Yp,Yts);

for j=1:1:length(Ksvm)

fsKtr=sKtr.^Ksvm(j);
fsKts=sKts.^Ksvm(j);

for i=1:1:length(Csvm)
for l=1:1:length(Csvm2)
[~,~,~,~,E(k,r_count,cv,i,l,j)]= TestK(fsKtr,fsKts,Yp,Yts,Csvm(i)/length(Yp),Csvm2(l));
end
end
end

end %k
end % cv
end % r

ERknn=mean(mean(Eknn(:,:,1:5),3),2);
ER=squeeze(mean(mean(E(:,:,1:5,:,:,:),3),2));
Precision=mean(mean(Pre(:,:,1:5),3),2);
Recall=mean(mean(Rec(:,:,1:5),3),2);
F1=mean(mean(Fone(:,:,1:5),3),2);
FalsePR=mean(mean(Fpr(:,:,1:5),3),2);


clear Kk Ks Ktr sKtr sKts fsKtr fsKts;
end


